#!/usr/local/bin/perl
# ----------------------------------------------------------------------
#
# 【RSStoTwitter】RSS1.0 をパースし、Twitter へ最新駄文を自動投稿
#
# Update:2011/03/18
#
# Copyright (c) 2011 by JJWorkshop HIRO. <http://jjworkshop.com/>
# ----------------------------------------------------------------------

use XML::Simple;
use LWP::UserAgent;
use Net::Twitter::Lite;
use Data::Dumper;
use Jcode;
use utf8;

# ----------------------------------------------------------------------
# 各種設定
# ----------------------------------------------------------------------

# RSS1.0 のファイルパス（フルパスでね！）
$rssPath  = "/home/......./web/index.rdf";

# 最終更新日保存ファイル（フルパスで、予め空で存在しないとダメよ）
$datePath = "/home/......./web/cgi-hoge/twpost/date.dat";

# ショートURL取得リクエスト用
$tinyurl = 'http://tinyurl.com/api-create.php?url=';

# ツイッター接続の設定（これは自分のやつを設定してね！）
$ckey = '**********XEZcOuytGF779A';
$csec = '**********ppVp6iw3QtVSR32l79SguwfAhjamMQI';
$atok = '**********cvNzxbD7GgLWy2BSkOWDA08fZ4hcQCUlqCnR3i92';
$atos = '**********OGtihITIbdpZAkytxE7ut4mgAQhqMJg';

# ----------------------------------------------------------------------
# 処理
# ----------------------------------------------------------------------

# XML データを読み込みパース
$xs = new XML::Simple(forcearray => 1, keyattr => []);
$xml = $xs->XMLin($rssPath);
#print Dumper $xml;


# 最終更新日を取得（ついでにロック）
$newDate = "";
open(IN,"<$datePath");
$lastDate = <IN>;
close(IN);
open(OUT,">$datePath");
flock(OUT,2);

# RSSをスキャン
$cnt = 0;
while (defined($xml->{item}->[$cnt])) {$cnt++};
for ($cnt--; $cnt>=0; $cnt--) {
	$date  = $xml->{item}->[$cnt]->{'dc:date'}->[0];
	if ($lastDate lt $date)	{
		my $titl = $xml->{item}->[$cnt]->{title}->[0];
		my $link = $xml->{item}->[$cnt]->{link}->[0];
		&postTwitter($titl,$link);
		$newDate = $date;
		last;
	}
}

# 最終更新日更新
if ($newDate eq "")	{$newDate = $lastDate};
print OUT $date;
close(OUT);
exit;


# Twitter へポスト
sub postTwitter {
	my ($titl,$link) = @_;
	$link = &shortUrl($link);
	print Jcode->new($titl,'utf8')->sjis;
	print "\n$link\n\n";

	my $twit = Net::Twitter::Lite->new(
	consumer_key    => $ckey,
	consumer_secret => $csec,
	);
	$twit->access_token ($atok);
	$twit->access_token_secret($atos);
	eval { $status = $twit->update("$titl\ $link") };
	if ( $@ ) {
		warn "update failed because: $@\n";
	}
}

# 短いURLに変換
sub shortUrl {
	my $ua = LWP::UserAgent->new();
	my $req = HTTP::Request->new('GET', "$tinyurl$_[0]");
	my $res = $ua->request($req);
	return(($res->is_success) ? $res->content : $_[0]);
}